## virtualgl 2.5.2

=== CMakeLists.txt ===
###############################################################################
# SETUP
###############################################################################

cmake_minimum_required(VERSION 2.8.11)
# Shut up CMake 3.1 and later
if(POLICY CMP0053)
	cmake_policy(SET CMP0053 OLD)
endif()

if(WIN32)
	project(VirtualGL-Utils)
else()
	project(VirtualGL)
endif()
string(TOLOWER ${CMAKE_PROJECT_NAME} CMAKE_PROJECT_NAME_LC)
set(VERSION 2.5.2)

macro(boolean_number var)
	if(${var})
		set(${var} 1)
	else()
		set(${var} 0)
	endif()
endmacro()

macro(report_option var desc)
	if(${var})
		message(STATUS "${desc} enabled (${var} = ${${var}})")
	else()
		message(STATUS "${desc} disabled (${var} = ${${var}})")
	endif()
endmacro()

if(UNIX AND NOT APPLE AND NOT CYGWIN)
	option(VGL_BUILDSERVER "Build ${CMAKE_PROJECT_NAME} server components" TRUE)
	boolean_number(VGL_BUILDSERVER)
	report_option(VGL_BUILDSERVER "VirtualGL server components")
endif()

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE Release)
endif()

message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

string(TIMESTAMP DEFAULT_BUILD "%Y%m%d")
set(BUILD ${DEFAULT_BUILD} CACHE STRING "Build string (default: ${DEFAULT_BUILD})")

message(STATUS "VERSION = ${VERSION}, BUILD = ${BUILD}")
add_definitions(-D__VERSION="${VERSION}" -D__BUILD="${BUILD}"
	-D__APPNAME="${CMAKE_PROJECT_NAME}")

# Detect CPU type and word size
math(EXPR BITS "${CMAKE_SIZEOF_VOID_P} * 8")
string(TOLOWER ${CMAKE_SYSTEM_PROCESSOR} CMAKE_SYSTEM_PROCESSOR_LC)
if(CMAKE_SYSTEM_PROCESSOR_LC MATCHES "x86_64" OR
	CMAKE_SYSTEM_PROCESSOR_LC MATCHES "amd64" OR
	CMAKE_SYSTEM_PROCESSOR_LC MATCHES "i[0-9]86" OR
	CMAKE_SYSTEM_PROCESSOR_LC MATCHES "x86" OR
	CMAKE_SYSTEM_PROCESSOR_LC MATCHES "ia32")
	if(BITS EQUAL 64)
		set(CPU_TYPE x86_64)
	else()
		set(CPU_TYPE i386)
	endif()
	if(NOT CMAKE_SYSTEM_PROCESSOR STREQUAL ${CPU_TYPE})
		set(CMAKE_SYSTEM_PROCESSOR ${CPU_TYPE})
	endif()
else()
	set(CPU_TYPE ${CMAKE_SYSTEM_PROCESSOR_LC})
endif()
message(STATUS "${BITS}-bit build (${CPU_TYPE})")

if(UNIX)
	set(CMAKE_INSTALL_DEFAULT_PREFIX /opt/${CMAKE_PROJECT_NAME})
	if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
		set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_DEFAULT_PREFIX}" CACHE PATH
			"Directory into which to install ${CMAKE_PROJECT_NAME} (default: ${CMAKE_INSTALL_DEFAULT_PREFIX})"
			FORCE)
	endif()
endif()
message(STATUS "CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}")

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
	set(GNUCC 1)
else()
	set(GNUCC 0)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
	set(GNUCXX 1)
else()
	set(GNUCXX 0)
endif()

# When the prefix is /opt/${CMAKE_PROJECT_NAME}, we assume that an "official"
# build is being created, and thus we install things into specific locations.

if((UNIX AND CMAKE_INSTALL_PREFIX STREQUAL "${CMAKE_INSTALL_DEFAULT_PREFIX}")
	OR WIN32)
	set(CMAKE_INSTALL_DEFAULT_DATAROOTDIR "")
	set(CMAKE_INSTALL_DEFAULT_DOCDIR "<CMAKE_INSTALL_DATAROOTDIR>/doc")
	if(UNIX)
		set(CMAKE_INSTALL_DEFAULT_LIBDIR "lib${BITS}")
	endif()
endif()
if(WIN32)
	set(CMAKE_INSTALL_DEFAULT_BINDIR ".")
	set(CMAKE_INSTALL_DEFAULT_DOCDIR ".")
endif()

include(cmakescripts/GNUInstallDirs.cmake)

macro(report_directory var)
	if(CMAKE_INSTALL_${var} STREQUAL CMAKE_INSTALL_FULL_${var})
		message(STATUS "CMAKE_INSTALL_${var} = ${CMAKE_INSTALL_${var}}")
	else()
		message(STATUS "CMAKE_INSTALL_${var} = ${CMAKE_INSTALL_${var}} (${CMAKE_INSTALL_FULL_${var}})")
	endif()
	mark_as_advanced(CLEAR CMAKE_INSTALL_${var})
endmacro()

set(DIRLIST "BINDIR;DATAROOTDIR;DOCDIR")
if(VGL_BUILDSERVER)
	list(APPEND DIRLIST "INCLUDEDIR;LIBDIR")
endif()
foreach(dir ${DIRLIST})
	report_directory(${dir})
endforeach()

include_directories(${CMAKE_SOURCE_DIR}/include)

if(MSVC)
	# Use the static C library for all build types
	foreach(var CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
		CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
		CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
		CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
		if(${var} MATCHES "/MD")
			string(REGEX REPLACE "/MD" "/MT" ${var} "${${var}}")
		endif()
	endforeach()

	add_definitions(-wd4996 -D_CRT_SECURE_NO_DEPRECATE)

	# Don't auto-generate manifests
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /MANIFEST:NO")

  # Avoid linker warning when doing Debug build if dependent libraries are
  # linked with the Release version of the static C library.
  set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:LIBCMT")
endif()

# This ensures that we don't depend on libstdc++ or libgcc
if(GNUCXX AND NOT APPLE AND NOT CYGWIN)
	set(DEFAULT_VGL_BUILDSTATIC 1)
	option(VGL_BUILDSTATIC
		"Link statically against libgcc and libstdc++, if possible"
		${DEFAULT_VGL_BUILDSTATIC})
	if(VGL_BUILDSTATIC)
		# For some reason, simply passing ${CMAKE_CXX_FLAGS} to the compiler in
		# execute_process() doesn't work.  Grrr...
		execute_process(COMMAND ${CMAKE_CXX_COMPILER} -m${BITS}
			--print-file-name=libstdc++.a OUTPUT_VARIABLE LIBSTDCPLUSPLUS
			RESULT_VARIABLE RESULT)
		string(REGEX REPLACE "\n" "" LIBSTDCPLUSPLUS ${LIBSTDCPLUSPLUS})
		if(RESULT MATCHES 0 AND LIBSTDCPLUSPLUS)
			message(STATUS "Linking with static libstdc++:\n   ${LIBSTDCPLUSPLUS}")
			file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/staticlib)
			execute_process(COMMAND ${CMAKE_COMMAND} -E remove
				${CMAKE_BINARY_DIR}/staticlib/libstdc++.a)
			execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink
				${LIBSTDCPLUSPLUS} ${CMAKE_BINARY_DIR}/staticlib/libstdc++.a)
			set(CMAKE_EXE_LINKER_FLAGS
				"${CMAKE_EXE_LINKER_FLAGS} -L${CMAKE_BINARY_DIR}/staticlib")
			set(CMAKE_SHARED_LINKER_FLAGS
				"${CMAKE_SHARED_LINKER_FLAGS} -L${CMAKE_BINARY_DIR}/staticlib")
		else()
			message(WARNING "Cannot find static libstdc++.  VirtualGL will depend on dynamic libstdc++.")
		endif()
		if(CMAKE_COMPILER_IS_GNUCXX)
			add_definitions(-static-libgcc)
		endif()
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libgcc")
		set(CMAKE_SHARED_LINKER_FLAGS
			"${CMAKE_SHARED_LINKER_FLAGS} -static-libgcc")
	endif()
endif()

# Don't build RPATH into libraries generated in the build directory
set(CMAKE_SKIP_BUILD_RPATH 1)

if(GNUCC)
	add_definitions(-D_GNU_SOURCE)
	if(NOT APPLE)
		set(MAPFLAG "-Wl,--version-script,")
	endif()
	# Use the maximum optimization level for release builds
	foreach(var CMAKE_C_FLAGS_RELEASE CMAKE_C_FLAGS_RELWITHDEBINFO
		CMAKE_CXX_FLAGS_RELEASE CMAKE_CXX_FLAGS_RELWITHDEBINFO)
		if(${var} MATCHES "-O2")
			string(REGEX REPLACE "-O2" "-O3" ${var} "${${var}}")
		endif()
	endforeach()
	set(MINUSZ "-Wl,-z,")
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	add_definitions(-D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
	set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lc")
	set(MAPFLAG "-Wl,-M,")
	if("${CMAKE_C_COMPILER_ID} ${CMAKE_CXX_COMPILER_ID}" MATCHES SunPro)
		add_definitions(-mt -norunpath)
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mt")
		set(CMAKE_SHARED_LINKER_FLAGS
			"-z direct -lCrun -z nodirect -mt ${CMAKE_SHARED_LINKER_FLAGS}")
		set(MAPFLAG "-M")
		set(MINUSZ "-z")

		# Use the maximum optimization level for release builds
		foreach(var CMAKE_C_FLAGS_RELEASE CMAKE_C_FLAGS_RELWITHDEBINFO
			CMAKE_CXX_FLAGS_RELEASE CMAKE_CXX_FLAGS_RELWITHDEBINFO)
			if(${var} MATCHES "-xO3")
				string(REGEX REPLACE "-xO3" "-xO5" ${var} "${${var}}")
			endif()
			if(${var} MATCHES "-xO2")
				string(REGEX REPLACE "-xO2" "-xO5" ${var} "${${var}}")
			endif()
		endforeach()
	endif()
endif()

option(VGL_USESSL
	"Enable SSL (Secure Sockets Layer) encryption feature in the VGL Transport"
	OFF)
boolean_number(VGL_USESSL)
report_option(VGL_USESSL "SSL (Secure Sockets Layer) encryption")
if(VGL_USESSL)
	include(FindOpenSSL)
	if(NOT OPENSSL_FOUND)
		message(STATUS "OpenSSL not found.  Disabling SSL support.")
	else()
		add_definitions(-DUSESSL)
		include_directories(${OPENSSL_INCLUDE_DIR})
	endif()
endif()

if(WIN32)

set(VGL_USEXV 0)
add_subdirectory(util)
add_subdirectory(wgldemos)
add_subdirectory(diags)

else()

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(CMAKE_LIBRARY_PATH /usr/lib/${CPU_TYPE}-linux-gnu;/usr/lib${BITS};/usr/lib)
endif()
include(FindX11)
include(FindOpenGL)

# Ensure that we build and link against the X11 version of OpenGL on OS X
if(APPLE)
	option(VGL_OSXOGLFIX "Adds Linker arguments needed to correctly select the X11 OpenGL Library" TRUE)
	if(VGL_OSXOGLFIX)
		set(CMAKE_EXE_LINKER_FLAGS
			"${CMAKE_EXE_LINKER_FLAGS} -Wl,-dylib_file,/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib:/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib")
		set(CMAKE_SHARED_LINKER_FLAGS
			"${CMAKE_SHARED_LINKER_FLAGS} -Wl,-dylib_file,/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib:/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib")
	endif()
	set(X11_X11_INCLUDE_PATH /usr/X11R6/include)
	set(OPENGL_gl_LIBRARY /usr/X11R6/lib/libGL.dylib)
	set(OPENGL_glu_LIBRARY /usr/X11R6/lib/libGLU.dylib)
endif()

# Not all OpenGL installations include all of the prototypes and constants in
# glx.h and glxext.h that are necessary to build VirtualGL.  If you know that
# yours does, then you can set VGL_SYSTEMGLX.
set(VGL_DEFAULTSYSTEMGLX 0)
option(VGL_SYSTEMGLX
	"Compile against system-supplied versions of glx.h and glxext.h instead of the in-tree versions."
	${VGL_DEFAULTSYSTEMGLX})
if(VGL_SYSTEMGLX)
	add_definitions(-DSYSGLXHEADERS)
endif()

include_directories(${X11_X11_INCLUDE_PATH})

option(VGL_USEXV "Enable X Video support" TRUE)
boolean_number(VGL_USEXV)

if(NOT X11_Xv_INCLUDE_PATH OR NOT X11_Xv_LIB)
	set(VGL_USEXV 0)
endif()
report_option(VGL_USEXV "X Video support")

if(VGL_USEXV)
	add_definitions(-DUSEXV)
	include_directories(${X11_Xv_INCLUDE_PATH})
endif()

if(NOT WIN32)
	include(cmakescripts/FindTurboJPEG.cmake)
endif()

if(NOT CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
	set(LIBDL dl)
endif()

endif() # WIN32

string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_UC)

set(EFFECTIVE_C_FLAGS "${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE_UC}}")
message(STATUS "Compiler flags = ${EFFECTIVE_C_FLAGS}")

set(EFFECTIVE_LD_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${CMAKE_EXE_LINKER_FLAGS_${CMAKE_BUILD_TYPE_UC}}")
message(STATUS "Linker flags = ${EFFECTIVE_LD_FLAGS}")


###############################################################################
# TARGETS
###############################################################################

if(NOT WIN32)

if(VGL_BUILDSERVER)
	set(DEFAULT_VGL_FAKER_NAME vglfaker)
	set(VGL_FAKER_NAME ${DEFAULT_VGL_FAKER_NAME} CACHE STRING
		"Base name for VirtualGL's GLX/OpenGL/X11 interposer library (default: ${DEFAULT_VGL_FAKER_NAME})")

	set(DEFAULT_VGL_DLFAKER_NAME dlfaker)
	set(VGL_DLFAKER_NAME ${DEFAULT_VGL_DLFAKER_NAME} CACHE STRING
		"Base name for VirtualGL's dlopen() interposer library (default: ${DEFAULT_VGL_DLFAKER_NAME})")

	set(DEFAULT_VGL_GEFAKER_NAME gefaker)
	set(VGL_GEFAKER_NAME ${DEFAULT_VGL_GEFAKER_NAME} CACHE STRING
		"Base name for VirtualGL's getenv() interposer library (default: ${DEFAULT_VGL_GEFAKER_NAME})")

	set(CMAKE_POSITION_INDEPENDENT_CODE 1)
endif()

set(FBXLIB fbx)
if(VGL_USEXV)
	set(FBXLIB ${FBXLIB};fbxv)
endif()

add_subdirectory(util)
add_subdirectory(common)
if(VGL_BUILDSERVER)
	add_subdirectory(server)
endif()
add_subdirectory(client)
add_subdirectory(glxdemos)
add_subdirectory(diags)
add_subdirectory(doc)

else()

install(FILES LICENSE.txt LGPL.txt DESTINATION ${CMAKE_INSTALL_DOCDIR})

endif() # WIN32


###############################################################################
# INSTALLATION AND PACKAGING

=== diags/CMakeLists.txt ===
if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	add_executable(cpustat cpustat.c)
	install(TARGETS cpustat DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

add_executable(imgdiff imgdiff.c)
target_link_libraries(imgdiff vglutil)
if(UNIX)
	target_link_libraries(imgdiff m)
endif()

if(MINGW)
	add_definitions(-DWINVER=0x0600)
endif()
if(WIN32)
	add_executable(tcbench tcbench.cpp)
else()
	add_executable(tcbench tcbench.cpp dsimple.c)
endif()
target_link_libraries(tcbench fbx)
install(TARGETS tcbench DESTINATION ${CMAKE_INSTALL_BINDIR})

=== doc/CMakeLists.txt ===
file(GLOB DOC_FILES
	${CMAKE_CURRENT_SOURCE_DIR}/*.gif
	${CMAKE_CURRENT_SOURCE_DIR}/*.png
	${CMAKE_CURRENT_SOURCE_DIR}/LICENSE*.txt
	${CMAKE_CURRENT_SOURCE_DIR}/LGPL.txt
	${CMAKE_CURRENT_SOURCE_DIR}/index.html
	${CMAKE_CURRENT_SOURCE_DIR}/virtualgl.css)

install(FILES ${DOC_FILES} ${CMAKE_SOURCE_DIR}/ChangeLog.md
	DESTINATION ${CMAKE_INSTALL_DOCDIR})

=== glxdemos/CMakeLists.txt ===
foreach(program glthreads glthreadsint sharedtex_mt)
	add_executable(${program} ${program}.c)
	target_link_libraries(${program} ${OPENGL_gl_LIBRARY} ${X11_X11_LIB} pthread
		m)
	set_property(TARGET ${program} PROPERTY COMPILE_FLAGS "-DPTHREADS")
endforeach()

foreach(program glxcontexts glxdemo glxgears glxgears_pixmap glxheads	glxpbdemo
	glxpixmap manywin offset overlay shape sharedtex testgl5 texture_from_pixmap
	wincopy xfont)
	add_executable(${program} ${program}.c)
	target_link_libraries(${program} ${OPENGL_gl_LIBRARY} ${X11_X11_LIB}
		${X11_Xext_LIB} m)
endforeach()

add_executable(glxinfo glxinfo.c)
target_link_libraries(glxinfo ${OPENGL_gl_LIBRARY} ${X11_X11_LIB}
	${OPENGL_glu_LIBRARY} m)
if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
	target_link_libraries(glxinfo Xmu)
endif()
install(TARGETS glxinfo DESTINATION ${CMAKE_INSTALL_BINDIR})

set(GLXSPHERES glxspheres)
if(BITS EQUAL 64)
	set(GLXSPHERES glxspheres64)
endif()
add_executable(${GLXSPHERES} glxspheres.c)
target_link_libraries(${GLXSPHERES} ${OPENGL_gl_LIBRARY} ${X11_X11_LIB}
	${OPENGL_glu_LIBRARY} m)
install(TARGETS ${GLXSPHERES} DESTINATION ${CMAKE_INSTALL_BINDIR})

foreach(program pbdemo pbinfo)
	add_executable(${program} ${program}.c pbutil.c)
	target_link_libraries(${program} ${OPENGL_gl_LIBRARY} ${X11_X11_LIB} m)
endforeach()

add_executable(xrotfontdemo xrotfontdemo.c xuserotfont.c)
target_link_libraries(xrotfontdemo ${OPENGL_gl_LIBRARY} ${X11_X11_LIB} m)

=== server/CMakeLists.txt ===
###############################################################################
# SERVER
###############################################################################

set(VGL_DEFAULTSYSTEMFLTK 0)
option(VGL_SYSTEMFLTK
	"Link against a system-supplied version of FLTK instead of the in-tree version."
	${VGL_DEFAULTSYSTEMFLTK})
if(VGL_SYSTEMFLTK)
	find_package(FLTK)
else()
	message(STATUS "Using in-tree version of FLTK")
	add_subdirectory(fltk)
	set(FLTK_INCLUDE_DIR fltk)
	set(FLTK_BASE_LIBRARY fltk_static)
endif()

configure_file(fakerconfig.h.in fakerconfig.h)
configure_file(vendor.h.in vendor.h)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}
	../common)

set(FBXFAKERLIB fbx-faker)
if(VGL_USEXV)
	set(FBXFAKERLIB ${FBXFAKERLIB};fbxv)
endif()

option(VGL_FAKEXCB "Interpose enough of the XCB API to make Qt 5 work" ON)
if(VGL_FAKEXCB)
	add_definitions(-DFAKEXCB)
	set(FAKER_XCB_SOURCES faker-xcb.cpp XCBConnHash.cpp)
	set(VGL_DEFAULTSYSTEMXCB 0)
	option(VGL_SYSTEMXCB
		"Compile against system-supplied versions of the XCB headers instead of the in-tree versions."
			${VGL_DEFAULTSYSTEMXCB})
	if(VGL_SYSTEMXCB)
		add_definitions(-DSYSXCBHEADERS)
	endif()
endif()

get_directory_property(DEFS_PROP COMPILE_DEFINITIONS)
foreach(def ${DEFS_PROP})
	set(DEFINES ${DEFINES};-D${def})
endforeach()
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/faker-mapfile
	COMMAND ${CMAKE_C_COMPILER} ${DEFINES} -E
		${CMAKE_CURRENT_SOURCE_DIR}/faker-mapfile.c
		> ${CMAKE_CURRENT_BINARY_DIR}/faker-mapfile
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/faker-mapfile.c)

set(FAKER_SOURCES
	ConfigHash.cpp
	ContextHash.cpp
	DisplayHash.cpp
	faker.cpp
	faker-gl.cpp
	faker-glx.cpp
	faker-sym.cpp
	faker-x11.cpp
	${FAKER_XCB_SOURCES}
	fakerconfig.cpp
	GlobalCriticalSection.cpp
	GLXDrawableHash.cpp
	glxvisual.cpp
	PixmapHash.cpp
	ReverseConfigHash.cpp
	TransPlugin.cpp
	VirtualDrawable.cpp
	VirtualPixmap.cpp
	VirtualWin.cpp
	VisualHash.cpp
	WindowHash.cpp
	X11Trans.cpp
	vglconfigLauncher.cpp
	VGLTrans.cpp)
if(VGL_USEXV)
	set(FAKER_SOURCES ${FAKER_SOURCES};XVTrans.cpp)
endif()

foreach(fakerlib ${VGL_FAKER_NAME} ${VGL_FAKER_NAME}-nodl)
	add_library(${fakerlib} SHARED ${FAKER_SOURCES})
	if(${fakerlib} STREQUAL ${VGL_FAKER_NAME} AND
		CMAKE_SYSTEM_NAME MATCHES "Linux")
		# GCC 4.6 and later on Linux apparently passes --as-needed to the linker,
		# and since libvglfaker.so loads OpenGL/GLX functions indirectly (with
		# dlopen()/dlsym()), --as-needed prevents the linker from adding a
		# DT_NEEDED tag for libGL to libvglfaker.so.  Without the following fix,
		# when attempting to vglrun applications that themselves indirectly load
		# OpenGL functions, libGL would not be loaded into the process, and VGL's
		# calls to dlsym(RTLD_NEXT, ...) would fail.
		set(NOASNEEDED "-Wl,--no-as-needed")
	endif()
	if(MAPFLAG)
		set_source_files_properties(faker-sym.cpp PROPERTIES
			OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/faker-mapfile)
		set_target_properties(${fakerlib} PROPERTIES
			LINK_FLAGS "${MINUSZ}defs ${MAPFLAG}${CMAKE_CURRENT_BINARY_DIR}/faker-mapfile ${NOASNEEDED}")
	else()
		set_target_properties(${fakerlib} PROPERTIES LINK_FLAGS "${MINUSZ}defs ${NOASNEEDED}")
	endif()
	target_link_libraries(${fakerlib} vglcommon ${FBXFAKERLIB} vglsocket m
		${LIBDL})
	if(${fakerlib} STREQUAL ${VGL_FAKER_NAME})
		target_link_libraries(${fakerlib} ${OPENGL_gl_LIBRARY})
	endif()
	if(CMAKE_SYSTEM_NAME STREQUAL "SunOS" AND GNUCXX)
		# For some reason, on SunOS/GCC CMake tries to use the C compiler to link
		# C++ shared libs.  Grrr...  (NOTE: This was fixed in CMake v3.4, so we
		# can remove this if we ever require a version later than that.)
		target_link_libraries(${fakerlib} stdc++)
	endif()
	install(TARGETS ${fakerlib} DESTINATION ${CMAKE_INSTALL_LIBDIR})
endforeach()

add_library(${VGL_DLFAKER_NAME} SHARED dlfaker.c)
target_link_libraries(${VGL_DLFAKER_NAME} ${LIBDL})
install(TARGETS ${VGL_DLFAKER_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

add_library(${VGL_GEFAKER_NAME} SHARED gefaker.c)
set_target_properties(${VGL_GEFAKER_NAME} PROPERTIES LINK_FLAGS "${MINUSZ}defs")
target_link_libraries(${VGL_GEFAKER_NAME} ${LIBDL})
install(TARGETS ${VGL_GEFAKER_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

set(HEADERS ../common/rr.h rrtransport.h)
install(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

include_directories(${FLTK_INCLUDE_DIR})
add_executable(vglconfig vglconfig.cpp fakerconfig.cpp)
target_link_libraries(vglconfig ${X11_X11_LIB} ${FLTK_BASE_LIBRARY} vglutil)
if(VGL_USEXV)
	target_link_libraries(vglconfig ${X11_Xv_LIB})
endif()
install(TARGETS vglconfig DESTINATION ${CMAKE_INSTALL_BINDIR})

install(PROGRAMS vglgenkey vgllogin vglserver_config DESTINATION
	${CMAKE_INSTALL_BINDIR})

configure_file(vglrun.in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/vglrun @ONLY)
execute_process(COMMAND chmod +x vglrun
	WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
install(PROGRAMS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/vglrun
	DESTINATION ${CMAKE_INSTALL_BINDIR})
configure_file(vglrun.vars.in
	${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/.vglrun.vars${BITS} @ONLY)
execute_process(COMMAND chmod +x .vglrun.vars${BITS}
	WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
install(PROGRAMS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/.vglrun.vars${BITS}
	DESTINATION ${CMAKE_INSTALL_BINDIR})


###############################################################################
# UNIT TESTS
###############################################################################

add_executable(x11transut x11transut.cpp fakerconfig.cpp X11Trans.cpp)
target_link_libraries(x11transut vglcommon ${FBXLIB} ${TJPEG_LIBRARY})

add_executable(vgltransut vgltransut.cpp VGLTrans.cpp
	fakerconfig.cpp)
target_link_libraries(vgltransut vglcommon ${FBXLIB} vglsocket
	${TJPEG_LIBRARY})

add_executable(dlfakerut dlfakerut.c)
target_link_libraries(dlfakerut ${X11_X11_LIB} ${LIBDL})

add_library(GLdlfakerut SHARED libGLdlfakerut.c)

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	add_library(deepbindtest SHARED libdeepbindtest.c)
	target_link_libraries(deepbindtest ${X11_X11_LIB} ${OPENGL_gl_LIBRARY})
	set_target_properties(deepbindtest PROPERTIES LINK_FLAGS "${MINUSZ}defs")
endif()

add_executable(fakerut fakerut.cpp fakerut-supplement.c)
target_link_libraries(fakerut "${MINUSZ}now ${OPENGL_gl_LIBRARY}"
	${OPENGL_glu_LIBRARY} "${MINUSZ}now ${X11_X11_LIB}" ${LIBDL} vglutil)

add_library(vgltrans_test SHARED testplugin.cpp VGLTrans.cpp)
if(VGL_USESSL AND CMAKE_SYSTEM_NAME STREQUAL "Linux")
	# Work around this issue:
	# http://rt.openssl.org/Ticket/Display.html?user=guest&pass=guest&id=1521
	set_target_properties(vgltrans_test PROPERTIES LINK_FLAGS "-Wl,-Bsymbolic")
endif()
target_link_libraries(vgltrans_test vglcommon ${FBXFAKERLIB} ${TJPEG_LIBRARY}
	vglsocket)
if(CMAKE_SYSTEM_NAME STREQUAL "SunOS" AND GNUCXX)
	target_link_libraries(vgltrans_test stdc++)
endif()

add_library(vgltrans_test2 SHARED testplugin2.cpp X11Trans.cpp)
target_link_libraries(vgltrans_test2 vglcommon ${FBXFAKERLIB} ${TJPEG_LIBRARY})
if(CMAKE_SYSTEM_NAME STREQUAL "SunOS" AND GNUCXX)
	target_link_libraries(vgltrans_test2 stdc++)
endif()

configure_file(servertest.in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/servertest)

=== util/CMakeLists.txt ===
add_library(vglutil STATIC GenericQ.cpp Log.cpp Mutex.cpp Thread.cpp bmp.c)
if(UNIX)
	target_link_libraries(vglutil pthread)
endif()
if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
	target_link_libraries(vglutil rt)
endif()

add_executable(bmptest bmptest.c md5.c md5hl.c)
target_link_libraries(bmptest vglutil)

add_library(vglsocket STATIC Socket.cpp)
target_link_libraries(vglsocket vglutil)
if(WIN32)
	target_link_libraries(vglsocket wsock32.lib)
endif()
if(VGL_USESSL)
	target_link_libraries(vglsocket ${OPENSSL_LIBRARIES})
endif()
if(CMAKE_SYSTEM_NAME MATCHES "SunOS")
	target_link_libraries(vglsocket socket xnet)
endif()

add_executable(nettest nettest.cpp)
target_link_libraries(nettest vglsocket)
if(CMAKE_SYSTEM_NAME MATCHES "SunOS")
	target_link_libraries(nettest kstat)
endif()
install(TARGETS nettest DESTINATION ${CMAKE_INSTALL_BINDIR})

add_library(fbx STATIC fbx.c)

if(VGL_BUILDSERVER)
	add_library(fbx-faker STATIC fbx.c)
	set_property(TARGET fbx-faker APPEND PROPERTY COMPILE_DEFINITIONS INFAKER)
	target_link_libraries(fbx-faker ${X11_X11_LIB} ${X11_Xext_LIB})
endif()

add_executable(fbxtest fbxtest.cpp)
target_link_libraries(fbxtest fbx vglutil)

if(UNIX)
	target_link_libraries(fbx ${X11_X11_LIB} ${X11_Xext_LIB})
endif()

if(VGL_USEXV)
	add_library(fbxv STATIC fbxv.c)
	target_link_libraries(fbxv ${X11_Xv_LIB} ${X11_X11_LIB} ${X11_Xext_LIB})

	add_executable(fbxvtest fbxvtest.c)
	target_link_libraries(fbxvtest fbxv)
endif()

add_executable(threadtest threadtest.cpp)
target_link_libraries(threadtest vglutil)

if(UNIX)
	option(VGL_USEIFR "Add nVidia Inband Frame Readback support to glreadtest"
		FALSE)
	if(VGL_USEIFR)
		message(STATUS "Enabling nVidia Inband Frame Readback support in glreadtest")
		set(DEFAULT_IFR_INCLUDE_DIR /opt/nvgrid/inc)
		set(IFR_INCLUDE_DIR ${DEFAULT_IFR_INCLUDE_DIR} CACHE PATH
			"Path to nVidia Inband Frame Readback include files (default: ${DEFAULT_IFR_INCLUDE_DIR})")
		add_definitions(-DUSEIFR)
		message(STATUS "IFR_INCLUDE_DIR = ${IFR_INCLUDE_DIR}")
		include_directories(${IFR_INCLUDE_DIR})
		include_directories(${IFR_INCLUDE_DIR}/../samples/common)
		set(IFRLIB nvidia-ifr)
	endif()

	add_executable(glreadtest glreadtest.cpp)
	target_link_libraries(glreadtest ${OPENGL_gl_LIBRARY} ${OPENGL_glu_LIBRARY}
		${X11_X11_LIB} ${IFRLIB})
	if(VGL_BUILDSERVER)
		install(TARGETS glreadtest DESTINATION ${CMAKE_INSTALL_BINDIR})
	endif()
endif()

if(WIN32)
	configure_file(utiltest-win.in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/utiltest)
else()
	configure_file(utiltest.in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/utiltest)
endif()

=== wgldemos/CMakeLists.txt ===
include(FindOpenGL)

add_executable(wglspheres wglspheres.c)
target_link_libraries(wglspheres ${OPENGL_gl_LIBRARY} ${OPENGL_glu_LIBRARY})

install(TARGETS wglspheres DESTINATION ${CMAKE_INSTALL_BINDIR})

=== server/fltk/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

if(GNUCC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-strict-aliasing -Wno-parentheses -Wno-char-subscripts")
endif()

if(GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing -Wno-parentheses -Wno-char-subscripts")
endif()

add_library(fltk_static STATIC
	Fl.cxx
	Fl_Adjuster.cxx
	Fl_Bitmap.cxx
	Fl_Browser.cxx
	Fl_Browser_.cxx
	Fl_Browser_load.cxx
	Fl_Box.cxx
	Fl_Button.cxx
	Fl_Chart.cxx
	Fl_Check_Browser.cxx
	Fl_Check_Button.cxx
	Fl_Choice.cxx
	Fl_Clock.cxx
	Fl_Color_Chooser.cxx
	Fl_Counter.cxx
	Fl_Dial.cxx
	Fl_Double_Window.cxx
	Fl_File_Browser.cxx
	Fl_File_Chooser.cxx
	Fl_File_Chooser2.cxx
	Fl_File_Icon.cxx
	Fl_File_Input.cxx
	Fl_Group.cxx
	Fl_Help_View.cxx
	Fl_Image.cxx
	Fl_Input.cxx
	Fl_Input_.cxx
	Fl_Light_Button.cxx
	Fl_Menu.cxx
	Fl_Menu_.cxx
	Fl_Menu_Bar.cxx
	Fl_Sys_Menu_Bar.cxx
	Fl_Menu_Button.cxx
	Fl_Menu_Window.cxx
	Fl_Menu_add.cxx
	Fl_Menu_global.cxx
	Fl_Multi_Label.cxx
	Fl_Overlay_Window.cxx
	Fl_Pack.cxx
	Fl_Pixmap.cxx
	Fl_Positioner.cxx
	Fl_Preferences.cxx
	Fl_Progress.cxx
	Fl_Repeat_Button.cxx
	Fl_Return_Button.cxx
	Fl_Roller.cxx
	Fl_Round_Button.cxx
	Fl_Scroll.cxx
	Fl_Scrollbar.cxx
	Fl_Shared_Image.cxx
	Fl_Single_Window.cxx
	Fl_Slider.cxx
	Fl_Tabs.cxx
	Fl_Text_Buffer.cxx
	Fl_Text_Display.cxx
	Fl_Text_Editor.cxx
	Fl_Tile.cxx
	Fl_Tiled_Image.cxx
	Fl_Tooltip.cxx
	Fl_Valuator.cxx
	Fl_Value_Input.cxx
	Fl_Value_Output.cxx
	Fl_Value_Slider.cxx
	Fl_Widget.cxx
	Fl_Window.cxx
	Fl_Window_fullscreen.cxx
	Fl_Window_hotspot.cxx
	Fl_Window_iconize.cxx
	Fl_Wizard.cxx
	Fl_XBM_Image.cxx
	Fl_XPM_Image.cxx
	Fl_abort.cxx
	Fl_add_idle.cxx
	Fl_arg.cxx
	Fl_compose.cxx
	Fl_display.cxx
	Fl_get_key.cxx
	Fl_get_system_colors.cxx
	Fl_grab.cxx
	Fl_lock.cxx
	Fl_own_colormap.cxx
	Fl_visual.cxx
	Fl_x.cxx
	filename_absolute.cxx
	filename_expand.cxx
	filename_ext.cxx
	filename_isdir.cxx
	filename_list.cxx
	filename_match.cxx
	filename_setext.cxx
	fl_arc.cxx
	fl_arci.cxx
	fl_ask.cxx
	fl_boxtype.cxx
	fl_color.cxx
	fl_cursor.cxx
	fl_curve.cxx
	fl_diamond_box.cxx
	fl_dnd.cxx
	fl_draw.cxx
	fl_draw_image.cxx
	fl_draw_pixmap.cxx
	fl_engraved_label.cxx
	fl_file_dir.cxx
	fl_font.cxx
	fl_labeltype.cxx
	fl_line_style.cxx
	fl_oval_box.cxx
	fl_overlay.cxx
	fl_overlay_visual.cxx
	fl_plastic.cxx
	fl_read_image.cxx
	fl_rect.cxx
	fl_round_box.cxx
	fl_rounded_box.cxx
	fl_set_font.cxx
	fl_set_fonts.cxx
	fl_scroll_area.cxx
	fl_shadow_box.cxx
	fl_shortcut.cxx
	fl_show_colormap.cxx
	fl_symbols.cxx
	fl_vertex.cxx
	flstring.c
	screen_xywh.cxx)

=== debian/changelog ===
virtualgl (2.5.2-1mx17+1) mx; urgency=medium

  * New upstream release.
  * Refresh remove-glxinfo.patch.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 09 Nov 2017 13:02:45 -0800

virtualgl (2.5.1-1mx15+1) mx; urgency=medium

  * New upstream release; build for MX 15.
  * debian/control: change build-dep to libturbojpeg0-dev.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 10 Nov 2016 13:06:02 -0800

virtualgl (2.4.1-1~trustyppa1) trusty; urgency=medium

  * New upstream release.

 -- Vincent Cheng <vcheng@debian.org>  Sat, 15 Aug 2015 00:18:59 -0700

virtualgl (2.3.3-1~trustyppa1) trusty; urgency=low

  * Initial release for Trusty

 -- Bruno Pagani <bruno.n.pagani@gmail.com>  Mon, 13 Jan 2014 20:22:24 +0200

## virtualgl 2.6.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 cmake_minimum_required(VERSION 2.8.11)
 # Shut up CMake 3.1 and later
 if(POLICY CMP0053)
-	cmake_policy(SET CMP0053 OLD)
+	cmake_policy(SET CMP0053 NEW)
 endif()
 
 if(WIN32)
@@ -14,7 +14,8 @@
 	project(VirtualGL)
 endif()
 string(TOLOWER ${CMAKE_PROJECT_NAME} CMAKE_PROJECT_NAME_LC)
-set(VERSION 2.5.2)
+set(VERSION 2.6.2)
+set(DOCVERSION 2.6.2)
 
 macro(boolean_number var)
 	if(${var})
@@ -71,10 +72,14 @@
 	if(NOT CMAKE_SYSTEM_PROCESSOR STREQUAL ${CPU_TYPE})
 		set(CMAKE_SYSTEM_PROCESSOR ${CPU_TYPE})
 	endif()
+elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "ppc64" AND BITS EQUAL 32)
+	set(CPU_TYPE ppc)
+	set(CMAKE_SYSTEM_PROCESSOR ${CPU_TYPE})
 else()
 	set(CPU_TYPE ${CMAKE_SYSTEM_PROCESSOR_LC})
 endif()
 message(STATUS "${BITS}-bit build (${CPU_TYPE})")
+add_definitions(-D__BITS=${BITS})
 
 if(UNIX)
 	set(CMAKE_INSTALL_DEFAULT_PREFIX /opt/${CMAKE_PROJECT_NAME})
@@ -150,9 +155,9 @@
 	# Don't auto-generate manifests
 	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /MANIFEST:NO")
 
-  # Avoid linker warning when doing Debug build if dependent libraries are
-  # linked with the Release version of the static C library.
-  set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:LIBCMT")
+	# Avoid linker warning when doing Debug build if dependent libraries are
+	# linked with the Release version of the static C library.
+	set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:LIBCMT")
 endif()
 
 # This ensures that we don't depend on libstdc++ or libgcc
@@ -168,7 +173,8 @@
 			--print-file-name=libstdc++.a OUTPUT_VARIABLE LIBSTDCPLUSPLUS
 			RESULT_VARIABLE RESULT)
 		string(REGEX REPLACE "\n" "" LIBSTDCPLUSPLUS ${LIBSTDCPLUSPLUS})
-		if(RESULT MATCHES 0 AND LIBSTDCPLUSPLUS)
+		if(RESULT MATCHES 0 AND LIBSTDCPLUSPLUS AND
+			NOT LIBSTDCPLUSPLUS STREQUAL "libstdc++.a")
 			message(STATUS "Linking with static libstdc++:\n   ${LIBSTDCPLUSPLUS}")
 			file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/staticlib)
 			execute_process(COMMAND ${CMAKE_COMMAND} -E remove
@@ -237,6 +243,37 @@
 	endif()
 endif()
 
+include(CheckCSourceCompiles)
+if(MSVC)
+	set(INLINE_OPTIONS "__inline;inline")
+else()
+	set(INLINE_OPTIONS "__inline__;inline")
+endif()
+option(VGL_FORCEINLINE "Force function inlining" TRUE)
+boolean_number(VGL_FORCEINLINE)
+if(VGL_FORCEINLINE)
+	if(MSVC)
+		list(INSERT INLINE_OPTIONS 0 "__forceinline")
+	else()
+		list(INSERT INLINE_OPTIONS 0 "inline __attribute__((always_inline))")
+		list(INSERT INLINE_OPTIONS 0 "__inline__ __attribute__((always_inline))")
+	endif()
+endif()
+foreach(inline ${INLINE_OPTIONS})
+	check_c_source_compiles("${inline} static int foo(void) { return 0; } int main(void) { return foo(); }"
+		INLINE_WORKS)
+	if(INLINE_WORKS)
+		set(INLINE ${inline})
+		break()
+	endif()
+endforeach()
+if(NOT INLINE_WORKS)
+	message(FATAL_ERROR "Could not determine how to inline functions.")
+endif()
+message(STATUS "INLINE = ${INLINE} (VGL_FORCEINLINE = ${VGL_FORCEINLINE})")
+configure_file(include/vglinline.h.in include/vglinline.h)
+include_directories(${CMAKE_BINARY_DIR}/include)
+
 option(VGL_USESSL
 	"Enable SSL (Secure Sockets Layer) encryption feature in the VGL Transport"
 	OFF)
@@ -265,6 +302,9 @@
 	set(CMAKE_LIBRARY_PATH /usr/lib/${CPU_TYPE}-linux-gnu;/usr/lib${BITS};/usr/lib)
 endif()
 include(FindX11)
+# Clarify that we need to link with the legacy OpenGL library (libGL) rather
+# than the GLVND OpenGL library.  This shuts up CMake 3.11 and later.
+set(OpenGL_GL_PREFERENCE LEGACY)
 include(FindOpenGL)
 
 # Ensure that we build and link against the X11 version of OpenGL on OS X
@@ -276,9 +316,9 @@
 		set(CMAKE_SHARED_LINKER_FLAGS
 			"${CMAKE_SHARED_LINKER_FLAGS} -Wl,-dylib_file,/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib:/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib")
 	endif()
-	set(X11_X11_INCLUDE_PATH /usr/X11R6/include)
-	set(OPENGL_gl_LIBRARY /usr/X11R6/lib/libGL.dylib)
-	set(OPENGL_glu_LIBRARY /usr/X11R6/lib/libGLU.dylib)
+	set(X11_X11_INCLUDE_PATH /usr/X11/include)
+	set(OPENGL_gl_LIBRARY /usr/X11/lib/libGL.dylib)
+	set(OPENGL_glu_LIBRARY /usr/X11/lib/libGLU.dylib)
 endif()
 
 # Not all OpenGL installations include all of the prototypes and constants in
@@ -323,52 +363,3 @@
 message(STATUS "Compiler flags = ${EFFECTIVE_C_FLAGS}")
 
 set(EFFECTIVE_LD_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${CMAKE_EXE_LINKER_FLAGS_${CMAKE_BUILD_TYPE_UC}}")
-message(STATUS "Linker flags = ${EFFECTIVE_LD_FLAGS}")
-
-
-###############################################################################
-# TARGETS
-###############################################################################
-
-if(NOT WIN32)
-
-if(VGL_BUILDSERVER)
-	set(DEFAULT_VGL_FAKER_NAME vglfaker)
-	set(VGL_FAKER_NAME ${DEFAULT_VGL_FAKER_NAME} CACHE STRING
-		"Base name for VirtualGL's GLX/OpenGL/X11 interposer library (default: ${DEFAULT_VGL_FAKER_NAME})")
-
-	set(DEFAULT_VGL_DLFAKER_NAME dlfaker)
-	set(VGL_DLFAKER_NAME ${DEFAULT_VGL_DLFAKER_NAME} CACHE STRING
-		"Base name for VirtualGL's dlopen() interposer library (default: ${DEFAULT_VGL_DLFAKER_NAME})")
-
-	set(DEFAULT_VGL_GEFAKER_NAME gefaker)
-	set(VGL_GEFAKER_NAME ${DEFAULT_VGL_GEFAKER_NAME} CACHE STRING
-		"Base name for VirtualGL's getenv() interposer library (default: ${DEFAULT_VGL_GEFAKER_NAME})")
-
-	set(CMAKE_POSITION_INDEPENDENT_CODE 1)
-endif()
-
-set(FBXLIB fbx)
-if(VGL_USEXV)
-	set(FBXLIB ${FBXLIB};fbxv)
-endif()
-
-add_subdirectory(util)
-add_subdirectory(common)
-if(VGL_BUILDSERVER)
-	add_subdirectory(server)
-endif()
-add_subdirectory(client)
-add_subdirectory(glxdemos)
-add_subdirectory(diags)
-add_subdirectory(doc)
-
-else()
-
-install(FILES LICENSE.txt LGPL.txt DESTINATION ${CMAKE_INSTALL_DOCDIR})
-
-endif() # WIN32
-
-
-###############################################################################
-# INSTALLATION AND PACKAGING

=== server/CMakeLists.txt ===
--- 
+++ 
@@ -125,13 +125,15 @@
 set(HEADERS ../common/rr.h rrtransport.h)
 install(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
 
-include_directories(${FLTK_INCLUDE_DIR})
+include_directories(SYSTEM ${FLTK_INCLUDE_DIR})
 add_executable(vglconfig vglconfig.cpp fakerconfig.cpp)
 target_link_libraries(vglconfig ${X11_X11_LIB} ${FLTK_BASE_LIBRARY} vglutil)
 if(VGL_USEXV)
 	target_link_libraries(vglconfig ${X11_Xv_LIB})
 endif()
 install(TARGETS vglconfig DESTINATION ${CMAKE_INSTALL_BINDIR})
+set_property(SOURCE vglconfig.cpp APPEND_STRING PROPERTY COMPILE_FLAGS
+	"-fno-strict-aliasing")
 
 install(PROGRAMS vglgenkey vgllogin vglserver_config DESTINATION
 	${CMAKE_INSTALL_BINDIR})
@@ -168,7 +170,8 @@
 
 if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
 	add_library(deepbindtest SHARED libdeepbindtest.c)
-	target_link_libraries(deepbindtest ${X11_X11_LIB} ${OPENGL_gl_LIBRARY})
+	target_link_libraries(deepbindtest ${X11_X11_LIB} ${OPENGL_gl_LIBRARY}
+		${LIBDL})
 	set_target_properties(deepbindtest PROPERTIES LINK_FLAGS "${MINUSZ}defs")
 endif()
 
@@ -194,4 +197,6 @@
 	target_link_libraries(vgltrans_test2 stdc++)
 endif()
 
-configure_file(servertest.in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/servertest)
+configure_file(servertest.in ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/servertest
+	@ONLY)
+execute_process(COMMAND chmod +x ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/servertest)

=== debian/changelog ===
virtualgl (2.6.2-0mx19+1) mx; urgency=medium

  * New Upstream release.

 -- Timothy E. Harris <maintainer@mxrepo.com>  Mon, 08 Jul 2019 09:56:54 -0400

=== debian/control ===
Source: virtualgl
Section: utils
Priority: extra
Maintainer: Steven Pusser <stevep@mxlinux.org>
Bugs: mailto: <stevep@mxlinux.org>
XSBC-Original-Maintainer: The Bumblebee Project <bumblebee@lists.launchpad.net>
Uploaders: Peter Lekensteyn <lekensteyn@gmail.com>,
 Bruno Pagani <bruno.n.pagani@gmail.com>
Build-Depends: debhelper (>= 9), cmake (>= 2.8.11),
 libturbojpeg0-dev,
 libx11-dev,
 libxext-dev,
 libgl1-mesa-dev,
 libglu1-mesa-dev,
 libxv-dev
Standards-Version: 3.9.5
Homepage: http://www.virtualgl.org/
Vcs-Browser: http://virtualgl.svn.sourceforge.net/viewvc/virtualgl/vgl/

Package: virtualgl
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, virtualgl-libs
Recommends: virtualgl-libs-ia32 [amd64]
Description: Toolkit for displaying OpenGL applications to thin clients
 VirtualGL is a toolkit that allows most Unix/Linux OpenGL applications to be
 remotely displayed with hardware 3D acceleration to thin clients, regardless
 of whether the clients have 3D capabilities, and regardless of the size of the
 3D data being rendered or the speed of the network.
 .
 Using the vglrun script, the VirtualGL "faker" is loaded into an OpenGL
 application at run time.  The faker then intercepts a handful of GLX calls,
 which it reroutes to the server's X display (the "3D X Server", which
 presumably has a 3D accelerator attached.)  The GLX commands are also
 dynamically modified such that all rendering is redirected into a Pbuffer
 instead of a window.  As each frame is rendered by the application, the faker
 reads back the pixels from the 3D accelerator and sends them to the
 "2D X Server" for compositing into the appropriate X Window.
 .
 VirtualGL can be used to give hardware-accelerated 3D capabilities to VNC or
 other X proxies that either lack OpenGL support or provide it through software
 rendering.  In a LAN environment, VGL can also be used with its built-in
 high-performance image transport, which sends the rendered 3D images to a
 remote client (vglclient) for compositing on a remote X server.  VirtualGL
 also supports image transport plugins, allowing the rendered 3D images to be
 sent or captured using other mechanisms.
 .
 VirtualGL is based upon ideas presented in various academic papers on
 this topic, including "A Generic Solution for Hardware-Accelerated Remote
 Visualization" (Stegmaier, Magallon, Ertl 2002) and "A Framework for
 Interactive Hardware Accelerated Remote 3D-Visualization" (Engel, Sommer,
 Ertl 2000.)

Package: virtualgl-libs
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Library files for virtualgl
 This package contains the libraries for virtualgl which are loaded when
 running vglrun.

Package: virtualgl-libs-ia32
Architecture: i386
Pre-Depends: ${misc:Pre-Depends}
Depends: virtualgl-libs, ${misc:Depends}
Multi-Arch: foreign
Description: Library files for virtualgl (32-bit)
 This package depends on 32-bit libraries for virtualgl. It can safely be
 removed after installation.

Package: virtualgl-dbg
Architecture: i386 amd64
Section: debug
Depends: virtualgl (=${binary:Version}), ${misc:Depends}
Description: VirtualGL - debugging symbols
 VirtualGL is a toolkit that allows most Unix/Linux OpenGL applications to be
 remotely displayed with hardware 3D acceleration to thin clients, regardless
 of whether the clients have 3D capabilities, and regardless of the size of the
 3D data being rendered or the speed of the network.
 .
 This package contains the debugging symbols for virtualgl.

Package: virtualgl-libs-dbg
Architecture: i386 amd64
Section: debug
Depends: virtualgl-libs (=${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Library files for virtualgl - debugging symbols
 This package contains the libraries for virtualgl which are loaded when
 running vglrun.
 .
 This package contains the debugging symbols for virtualgl-libs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifeq ($(DEB_BUILD_ARCH), amd64)
	FAKELIBDIR = /usr/lib/virtualgl/fakelib/64
else
	FAKELIBDIR = /usr/lib/virtualgl/fakelib
endif
%:
	dh $@ 

override_dh_auto_configure:
	cmake -G "Unix Makefiles" \
	-DTJPEG_LIBRARY=/usr/lib/$(DEB_HOST_MULTIARCH)/libturbojpeg.so.0 \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DVGL_FAKELIBDIR=$(FAKELIBDIR) \
	-DVGL_DOCDIR=/usr/share/doc/virtualgl -DVGL_INCLUDEDIR=/usr/include \
	-DVGL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH) -DVGL_BINDIR=/usr/bin \
	-DCMAKE_LIBRARY_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_install:
	make install DESTDIR=$(CURDIR)/debian/tmp
override_dh_strip:
	dh_strip --dbg-package=virtualgl-dbg -X usr/lib
	dh_strip --dbg-package=virtualgl-libs-dbg -X usr/bin
